import React from 'react';
import PropTypes from 'prop-types';
/**
 * Tabheader is used for Large Tabs with subheadings;
 * @param props
 * @returns {XML}
 * @constructor
 */

var TabHeader = function TabHeader(props) {
  var heading = props.heading,
      subHeading = props.subHeading;
  return (//Element type requires by UI-Collab Style
    React.createElement("cui-tab-heading", null, heading, subHeading && React.createElement("div", null, subHeading))
  );
};

TabHeader.propTypes = {
  /**
   * required heading prop type
   */
  heading: PropTypes.string.isRequired,

  /**
   * optional subHeading prop type
   */
  subHeading: PropTypes.string
};
TabHeader.defaultProps = {
  subHeading: ''
};
TabHeader.displayName = 'TabHeader';
export default TabHeader;